
# Common files
require 'connectwise-ruby-sdk/api_client'
require 'connectwise-ruby-sdk/api_error'
require 'connectwise-ruby-sdk/version'
require 'connectwise-ruby-sdk/configuration'

# Models
require 'connectwise-ruby-sdk/models/accounting_batch'
require 'connectwise-ruby-sdk/models/accounting_package'
require 'connectwise-ruby-sdk/models/activity'
require 'connectwise-ruby-sdk/models/activity_reference'
require 'connectwise-ruby-sdk/models/activity_status'
require 'connectwise-ruby-sdk/models/activity_status_reference'
require 'connectwise-ruby-sdk/models/activity_stopwatch'
require 'connectwise-ruby-sdk/models/activity_type'
require 'connectwise-ruby-sdk/models/activity_type_reference'
require 'connectwise-ruby-sdk/models/addition'
require 'connectwise-ruby-sdk/models/address_format'
require 'connectwise-ruby-sdk/models/address_format_reference'
require 'connectwise-ruby-sdk/models/adjustment'
require 'connectwise-ruby-sdk/models/adjustment_detail'
require 'connectwise-ruby-sdk/models/adjustment_reference'
require 'connectwise-ruby-sdk/models/adjustment_type'
require 'connectwise-ruby-sdk/models/adjustment_type_reference'
require 'connectwise-ruby-sdk/models/agreement'
require 'connectwise-ruby-sdk/models/agreement_batch_setup'
require 'connectwise-ruby-sdk/models/agreement_reference'
require 'connectwise-ruby-sdk/models/agreement_site'
require 'connectwise-ruby-sdk/models/agreement_type'
require 'connectwise-ruby-sdk/models/agreement_type_board_default'
require 'connectwise-ruby-sdk/models/agreement_type_reference'
require 'connectwise-ruby-sdk/models/agreement_type_work_role'
require 'connectwise-ruby-sdk/models/agreement_type_work_role_exclusion'
require 'connectwise-ruby-sdk/models/agreement_type_work_type'
require 'connectwise-ruby-sdk/models/agreement_type_work_type_exclusion'
require 'connectwise-ruby-sdk/models/agreement_work_role'
require 'connectwise-ruby-sdk/models/agreement_work_role_exclusion'
require 'connectwise-ruby-sdk/models/agreement_work_type'
require 'connectwise-ruby-sdk/models/agreement_work_type_exclusion'
require 'connectwise-ruby-sdk/models/audit_trail_entry'
require 'connectwise-ruby-sdk/models/auth_anvil'
require 'connectwise-ruby-sdk/models/automate_script_reference'
require 'connectwise-ruby-sdk/models/batch_request'
require 'connectwise-ruby-sdk/models/batch_response'
require 'connectwise-ruby-sdk/models/billing_cycle'
require 'connectwise-ruby-sdk/models/billing_cycle_reference'
require 'connectwise-ruby-sdk/models/billing_delivery_reference'
require 'connectwise-ruby-sdk/models/billing_options_reference'
require 'connectwise-ruby-sdk/models/billing_setup'
require 'connectwise-ruby-sdk/models/billing_setup_routing'
require 'connectwise-ruby-sdk/models/billing_status'
require 'connectwise-ruby-sdk/models/billing_status_reference'
require 'connectwise-ruby-sdk/models/billing_term'
require 'connectwise-ruby-sdk/models/billing_terms_reference'
require 'connectwise-ruby-sdk/models/board'
require 'connectwise-ruby-sdk/models/board_auto_assign_resource'
require 'connectwise-ruby-sdk/models/board_auto_template'
require 'connectwise-ruby-sdk/models/board_copy'
require 'connectwise-ruby-sdk/models/board_default'
require 'connectwise-ruby-sdk/models/board_excluded_member'
require 'connectwise-ruby-sdk/models/board_item'
require 'connectwise-ruby-sdk/models/board_item_association'
require 'connectwise-ruby-sdk/models/board_notification'
require 'connectwise-ruby-sdk/models/board_reference'
require 'connectwise-ruby-sdk/models/board_status'
require 'connectwise-ruby-sdk/models/board_status_notification'
require 'connectwise-ruby-sdk/models/board_sub_type'
require 'connectwise-ruby-sdk/models/board_team'
require 'connectwise-ruby-sdk/models/board_type'
require 'connectwise-ruby-sdk/models/board_type_sub_type_item_association'
require 'connectwise-ruby-sdk/models/calendar'
require 'connectwise-ruby-sdk/models/calendar_reference'
require 'connectwise-ruby-sdk/models/calendar_setup_reference'
require 'connectwise-ruby-sdk/models/callback_entry'
require 'connectwise-ruby-sdk/models/campaign'
require 'connectwise-ruby-sdk/models/campaign_audit'
require 'connectwise-ruby-sdk/models/campaign_reference'
require 'connectwise-ruby-sdk/models/campaign_status'
require 'connectwise-ruby-sdk/models/campaign_status_reference'
require 'connectwise-ruby-sdk/models/campaign_sub_type'
require 'connectwise-ruby-sdk/models/campaign_sub_type_reference'
require 'connectwise-ruby-sdk/models/campaign_type'
require 'connectwise-ruby-sdk/models/campaign_type_reference'
require 'connectwise-ruby-sdk/models/catalog_component'
require 'connectwise-ruby-sdk/models/catalog_item'
require 'connectwise-ruby-sdk/models/catalog_item_reference'
require 'connectwise-ruby-sdk/models/category'
require 'connectwise-ruby-sdk/models/certification'
require 'connectwise-ruby-sdk/models/certification_reference'
require 'connectwise-ruby-sdk/models/charge_code'
require 'connectwise-ruby-sdk/models/charge_code_expense_type'
require 'connectwise-ruby-sdk/models/charge_code_reference'
require 'connectwise-ruby-sdk/models/classification'
require 'connectwise-ruby-sdk/models/classification_reference'
require 'connectwise-ruby-sdk/models/clear_picker_request'
require 'connectwise-ruby-sdk/models/code'
require 'connectwise-ruby-sdk/models/commission'
require 'connectwise-ruby-sdk/models/communication_type_reference'
require 'connectwise-ruby-sdk/models/company'
require 'connectwise-ruby-sdk/models/company_custom_note'
require 'connectwise-ruby-sdk/models/company_group'
require 'connectwise-ruby-sdk/models/company_management_summary'
require 'connectwise-ruby-sdk/models/company_merge'
require 'connectwise-ruby-sdk/models/company_note'
require 'connectwise-ruby-sdk/models/company_picker_item'
require 'connectwise-ruby-sdk/models/company_reference'
require 'connectwise-ruby-sdk/models/company_site'
require 'connectwise-ruby-sdk/models/company_status'
require 'connectwise-ruby-sdk/models/company_status_reference'
require 'connectwise-ruby-sdk/models/company_team'
require 'connectwise-ruby-sdk/models/company_type'
require 'connectwise-ruby-sdk/models/company_type_reference'
require 'connectwise-ruby-sdk/models/configuration'
require 'connectwise-ruby-sdk/models/configuration_question'
require 'connectwise-ruby-sdk/models/configuration_reference'
require 'connectwise-ruby-sdk/models/configuration_status'
require 'connectwise-ruby-sdk/models/configuration_status_reference'
require 'connectwise-ruby-sdk/models/configuration_type'
require 'connectwise-ruby-sdk/models/configuration_type_question'
require 'connectwise-ruby-sdk/models/configuration_type_question_reference'
require 'connectwise-ruby-sdk/models/configuration_type_question_value'
require 'connectwise-ruby-sdk/models/configuration_type_reference'
require 'connectwise-ruby-sdk/models/connect_wise_hosted_setup'
require 'connectwise-ruby-sdk/models/contact'
require 'connectwise-ruby-sdk/models/contact_communication'
require 'connectwise-ruby-sdk/models/contact_communication_item'
require 'connectwise-ruby-sdk/models/contact_department'
require 'connectwise-ruby-sdk/models/contact_department_reference'
require 'connectwise-ruby-sdk/models/contact_group'
require 'connectwise-ruby-sdk/models/contact_note'
require 'connectwise-ruby-sdk/models/contact_reference'
require 'connectwise-ruby-sdk/models/contact_relationship'
require 'connectwise-ruby-sdk/models/contact_type'
require 'connectwise-ruby-sdk/models/contact_type_reference'
require 'connectwise-ruby-sdk/models/conversion'
require 'connectwise-ruby-sdk/models/corporate_structure'
require 'connectwise-ruby-sdk/models/corporate_structure_level'
require 'connectwise-ruby-sdk/models/corporate_structure_level_reference'
require 'connectwise-ruby-sdk/models/count'
require 'connectwise-ruby-sdk/models/country'
require 'connectwise-ruby-sdk/models/country_reference'
require 'connectwise-ruby-sdk/models/create_accounting_batch_request'
require 'connectwise-ruby-sdk/models/crm'
require 'connectwise-ruby-sdk/models/currency'
require 'connectwise-ruby-sdk/models/currency_reference'
require 'connectwise-ruby-sdk/models/custom_field_value'
require 'connectwise-ruby-sdk/models/custom_report'
require 'connectwise-ruby-sdk/models/custom_report_parameter'
require 'connectwise-ruby-sdk/models/custom_report_reference'
require 'connectwise-ruby-sdk/models/delivery_method'
require 'connectwise-ruby-sdk/models/department'
require 'connectwise-ruby-sdk/models/department_location'
require 'connectwise-ruby-sdk/models/department_mananager'
require 'connectwise-ruby-sdk/models/dispatch_member'
require 'connectwise-ruby-sdk/models/document_info'
require 'connectwise-ruby-sdk/models/document_reference'
require 'connectwise-ruby-sdk/models/document_setup'
require 'connectwise-ruby-sdk/models/duty_manager'
require 'connectwise-ruby-sdk/models/email_connector'
require 'connectwise-ruby-sdk/models/email_connector_parsing_rule'
require 'connectwise-ruby-sdk/models/email_connector_parsing_style'
require 'connectwise-ruby-sdk/models/email_connector_parsing_style_reference'
require 'connectwise-ruby-sdk/models/email_connector_parsing_type_reference'
require 'connectwise-ruby-sdk/models/email_connector_parsing_variable_reference'
require 'connectwise-ruby-sdk/models/email_connector_reference'
require 'connectwise-ruby-sdk/models/email_opened'
require 'connectwise-ruby-sdk/models/email_template_reference'
require 'connectwise-ruby-sdk/models/email_token'
require 'connectwise-ruby-sdk/models/endpoint_request'
require 'connectwise-ruby-sdk/models/endpoint_response'
require 'connectwise-ruby-sdk/models/entity_type_reference'
require 'connectwise-ruby-sdk/models/error'
require 'connectwise-ruby-sdk/models/expense_entry'
require 'connectwise-ruby-sdk/models/expense_report'
require 'connectwise-ruby-sdk/models/expense_tax'
require 'connectwise-ruby-sdk/models/expense_tax_type_reference'
require 'connectwise-ruby-sdk/models/expense_type'
require 'connectwise-ruby-sdk/models/expense_type_exemption'
require 'connectwise-ruby-sdk/models/expense_type_external_integration_reference'
require 'connectwise-ruby-sdk/models/expense_type_reference'
require 'connectwise-ruby-sdk/models/export_accounting_batch_request'
require 'connectwise-ruby-sdk/models/external_expense_type_integration_reference'
require 'connectwise-ruby-sdk/models/external_integration_status_reference'
require 'connectwise-ruby-sdk/models/external_work_type_integration_reference'
require 'connectwise-ruby-sdk/models/filter_values'
require 'connectwise-ruby-sdk/models/forecast'
require 'connectwise-ruby-sdk/models/form_submitted'
require 'connectwise-ruby-sdk/models/gl_export'
require 'connectwise-ruby-sdk/models/gl_export_adjustment_transaction'
require 'connectwise-ruby-sdk/models/gl_export_adjustment_transaction_detail'
require 'connectwise-ruby-sdk/models/gl_export_customer'
require 'connectwise-ruby-sdk/models/gl_export_expense'
require 'connectwise-ruby-sdk/models/gl_export_expense_bill'
require 'connectwise-ruby-sdk/models/gl_export_expense_bill_detail'
require 'connectwise-ruby-sdk/models/gl_export_expense_offset'
require 'connectwise-ruby-sdk/models/gl_export_inventory_transfer'
require 'connectwise-ruby-sdk/models/gl_export_inventory_transfer_offset'
require 'connectwise-ruby-sdk/models/gl_export_purchase_transaction'
require 'connectwise-ruby-sdk/models/gl_export_purchase_transaction_detail'
require 'connectwise-ruby-sdk/models/gl_export_purchase_transaction_detail_tax'
require 'connectwise-ruby-sdk/models/gl_export_settings'
require 'connectwise-ruby-sdk/models/gl_export_transaction'
require 'connectwise-ruby-sdk/models/gl_export_transaction_detail'
require 'connectwise-ruby-sdk/models/gl_export_vendor'
require 'connectwise-ruby-sdk/models/generic_id_identifier_reference'
require 'connectwise-ruby-sdk/models/group'
require 'connectwise-ruby-sdk/models/group_reference'
require 'connectwise-ruby-sdk/models/guid'
require 'connectwise-ruby-sdk/models/holiday'
require 'connectwise-ruby-sdk/models/holiday_list'
require 'connectwise-ruby-sdk/models/holiday_list_reference'
require 'connectwise-ruby-sdk/models/imap'
require 'connectwise-ruby-sdk/models/imap_setup_reference'
require 'connectwise-ruby-sdk/models/impact'
require 'connectwise-ruby-sdk/models/import_mass_maintenance'
require 'connectwise-ruby-sdk/models/in_out_board'
require 'connectwise-ruby-sdk/models/in_out_type'
require 'connectwise-ruby-sdk/models/in_out_type_reference'
require 'connectwise-ruby-sdk/models/info'
require 'connectwise-ruby-sdk/models/integrator_login'
require 'connectwise-ruby-sdk/models/integrator_login_reference'
require 'connectwise-ruby-sdk/models/invoice'
require 'connectwise-ruby-sdk/models/invoice_email_template'
require 'connectwise-ruby-sdk/models/invoice_reference'
require 'connectwise-ruby-sdk/models/invoice_template'
require 'connectwise-ruby-sdk/models/invoice_template_reference'
require 'connectwise-ruby-sdk/models/invoice_template_setup'
require 'connectwise-ruby-sdk/models/iv_item_reference'
require 'connectwise-ruby-sdk/models/j_array'
require 'connectwise-ruby-sdk/models/j_object'
require 'connectwise-ruby-sdk/models/kpi'
require 'connectwise-ruby-sdk/models/kpi_category'
require 'connectwise-ruby-sdk/models/kpi_category_reference'
require 'connectwise-ruby-sdk/models/kpi_reference'
require 'connectwise-ruby-sdk/models/knowledge_base_article'
require 'connectwise-ruby-sdk/models/knowledgebase_article'
require 'connectwise-ruby-sdk/models/ldap_configuration'
require 'connectwise-ruby-sdk/models/ldap_configuration_reference'
require 'connectwise-ruby-sdk/models/legacy_sub_category'
require 'connectwise-ruby-sdk/models/link'
require 'connectwise-ruby-sdk/models/link_clicked'
require 'connectwise-ruby-sdk/models/location'
require 'connectwise-ruby-sdk/models/location_department'
require 'connectwise-ruby-sdk/models/location_work_role'
require 'connectwise-ruby-sdk/models/managed_devices_integration'
require 'connectwise-ruby-sdk/models/managed_devices_integration_cross_reference'
require 'connectwise-ruby-sdk/models/managed_devices_integration_login'
require 'connectwise-ruby-sdk/models/managed_devices_integration_notification'
require 'connectwise-ruby-sdk/models/managed_devices_integration_reference'
require 'connectwise-ruby-sdk/models/management'
require 'connectwise-ruby-sdk/models/management_backup'
require 'connectwise-ruby-sdk/models/management_email'
require 'connectwise-ruby-sdk/models/management_it_solution'
require 'connectwise-ruby-sdk/models/management_it_solution_agreement_interface_parameter'
require 'connectwise-ruby-sdk/models/management_log_document_info'
require 'connectwise-ruby-sdk/models/management_network_security'
require 'connectwise-ruby-sdk/models/management_report_notification'
require 'connectwise-ruby-sdk/models/management_solution_reference'
require 'connectwise-ruby-sdk/models/manufacturer'
require 'connectwise-ruby-sdk/models/manufacturer_reference'
require 'connectwise-ruby-sdk/models/market_description'
require 'connectwise-ruby-sdk/models/marketing_company'
require 'connectwise-ruby-sdk/models/marketing_contact'
require 'connectwise-ruby-sdk/models/member'
require 'connectwise-ruby-sdk/models/member_accrual'
require 'connectwise-ruby-sdk/models/member_certification'
require 'connectwise-ruby-sdk/models/member_deactivation'
require 'connectwise-ruby-sdk/models/member_delegation'
require 'connectwise-ruby-sdk/models/member_reference'
require 'connectwise-ruby-sdk/models/member_skill'
require 'connectwise-ruby-sdk/models/member_type_reference'
require 'connectwise-ruby-sdk/models/menu_entry'
require 'connectwise-ruby-sdk/models/menu_entry_location'
require 'connectwise-ruby-sdk/models/menu_location_reference'
require 'connectwise-ruby-sdk/models/metadata'
require 'connectwise-ruby-sdk/models/my_company_coo_role'
require 'connectwise-ruby-sdk/models/my_company_controller_role'
require 'connectwise-ruby-sdk/models/my_company_dispatch_role'
require 'connectwise-ruby-sdk/models/my_company_duty_manager_role'
require 'connectwise-ruby-sdk/models/my_company_president_role'
require 'connectwise-ruby-sdk/models/my_company_service_manager_role'
require 'connectwise-ruby-sdk/models/note_type'
require 'connectwise-ruby-sdk/models/note_type_reference'
require 'connectwise-ruby-sdk/models/notification_recipient'
require 'connectwise-ruby-sdk/models/notification_recipient_reference'
require 'connectwise-ruby-sdk/models/notify_type_reference'
require 'connectwise-ruby-sdk/models/opportunity'
require 'connectwise-ruby-sdk/models/opportunity_contact'
require 'connectwise-ruby-sdk/models/opportunity_note'
require 'connectwise-ruby-sdk/models/opportunity_priority_reference'
require 'connectwise-ruby-sdk/models/opportunity_probability_reference'
require 'connectwise-ruby-sdk/models/opportunity_rating'
require 'connectwise-ruby-sdk/models/opportunity_rating_reference'
require 'connectwise-ruby-sdk/models/opportunity_reference'
require 'connectwise-ruby-sdk/models/opportunity_sales_role_reference'
require 'connectwise-ruby-sdk/models/opportunity_stage'
require 'connectwise-ruby-sdk/models/opportunity_stage_reference'
require 'connectwise-ruby-sdk/models/opportunity_status'
require 'connectwise-ruby-sdk/models/opportunity_status_reference'
require 'connectwise-ruby-sdk/models/opportunity_to_agreement_conversion'
require 'connectwise-ruby-sdk/models/opportunity_to_project_conversion'
require 'connectwise-ruby-sdk/models/opportunity_to_sales_order_conversion'
require 'connectwise-ruby-sdk/models/opportunity_to_service_ticket_conversion'
require 'connectwise-ruby-sdk/models/opportunity_type'
require 'connectwise-ruby-sdk/models/opportunity_type_reference'
require 'connectwise-ruby-sdk/models/order'
require 'connectwise-ruby-sdk/models/order_status'
require 'connectwise-ruby-sdk/models/order_status_email_template'
require 'connectwise-ruby-sdk/models/order_status_email_template_reference'
require 'connectwise-ruby-sdk/models/order_status_notification'
require 'connectwise-ruby-sdk/models/order_status_reference'
require 'connectwise-ruby-sdk/models/other'
require 'connectwise-ruby-sdk/models/ownership_type'
require 'connectwise-ruby-sdk/models/ownership_type_reference'
require 'connectwise-ruby-sdk/models/parsing_type'
require 'connectwise-ruby-sdk/models/parsing_variable'
require 'connectwise-ruby-sdk/models/patch_operation'
require 'connectwise-ruby-sdk/models/payment'
require 'connectwise-ruby-sdk/models/payment_method_reference'
require 'connectwise-ruby-sdk/models/payment_type'
require 'connectwise-ruby-sdk/models/phase_status_reference'
require 'connectwise-ruby-sdk/models/portal_calendar'
require 'connectwise-ruby-sdk/models/portal_configuration'
require 'connectwise-ruby-sdk/models/portal_configuration_invoice_setup'
require 'connectwise-ruby-sdk/models/portal_configuration_opportunity_setup'
require 'connectwise-ruby-sdk/models/portal_configuration_password_email_setup'
require 'connectwise-ruby-sdk/models/portal_configuration_project_setup'
require 'connectwise-ruby-sdk/models/portal_configuration_reference'
require 'connectwise-ruby-sdk/models/portal_configuration_service_setup'
require 'connectwise-ruby-sdk/models/portal_report'
require 'connectwise-ruby-sdk/models/portal_security'
require 'connectwise-ruby-sdk/models/portal_security_level'
require 'connectwise-ruby-sdk/models/pricing_break'
require 'connectwise-ruby-sdk/models/pricing_detail'
require 'connectwise-ruby-sdk/models/pricing_schedule'
require 'connectwise-ruby-sdk/models/pricing_schedule_reference'
require 'connectwise-ruby-sdk/models/priority'
require 'connectwise-ruby-sdk/models/priority_reference'
require 'connectwise-ruby-sdk/models/product_category_reference'
require 'connectwise-ruby-sdk/models/product_component'
require 'connectwise-ruby-sdk/models/product_item'
require 'connectwise-ruby-sdk/models/product_item_reference'
require 'connectwise-ruby-sdk/models/product_picking_shipping_detail'
require 'connectwise-ruby-sdk/models/product_recurring'
require 'connectwise-ruby-sdk/models/product_reference'
require 'connectwise-ruby-sdk/models/product_sub_category_reference'
require 'connectwise-ruby-sdk/models/product_type'
require 'connectwise-ruby-sdk/models/product_type_exemption'
require 'connectwise-ruby-sdk/models/product_type_reference'
require 'connectwise-ruby-sdk/models/project'
require 'connectwise-ruby-sdk/models/project_board_reference'
require 'connectwise-ruby-sdk/models/project_contact'
require 'connectwise-ruby-sdk/models/project_manager'
require 'connectwise-ruby-sdk/models/project_note'
require 'connectwise-ruby-sdk/models/project_phase'
require 'connectwise-ruby-sdk/models/project_phase_reference'
require 'connectwise-ruby-sdk/models/project_reference'
require 'connectwise-ruby-sdk/models/project_role_reference'
require 'connectwise-ruby-sdk/models/project_security_role'
require 'connectwise-ruby-sdk/models/project_security_role_setting'
require 'connectwise-ruby-sdk/models/project_status'
require 'connectwise-ruby-sdk/models/project_status_reference'
require 'connectwise-ruby-sdk/models/project_teammember'
require 'connectwise-ruby-sdk/models/project_type'
require 'connectwise-ruby-sdk/models/project_type_reference'
require 'connectwise-ruby-sdk/models/purchase_order'
require 'connectwise-ruby-sdk/models/purchase_order_line_item'
require 'connectwise-ruby-sdk/models/purchase_order_reference'
require 'connectwise-ruby-sdk/models/purchase_order_status'
require 'connectwise-ruby-sdk/models/purchase_order_status_email_template'
require 'connectwise-ruby-sdk/models/purchase_order_status_email_template_reference'
require 'connectwise-ruby-sdk/models/purchase_order_status_notification'
require 'connectwise-ruby-sdk/models/purchase_order_status_reference'
require 'connectwise-ruby-sdk/models/purchasing'
require 'connectwise-ruby-sdk/models/rma_action'
require 'connectwise-ruby-sdk/models/rma_disposition'
require 'connectwise-ruby-sdk/models/relationship_reference'
require 'connectwise-ruby-sdk/models/reminder_reference'
require 'connectwise-ruby-sdk/models/report'
require 'connectwise-ruby-sdk/models/report_card'
require 'connectwise-ruby-sdk/models/report_card_detail'
require 'connectwise-ruby-sdk/models/report_card_reference'
require 'connectwise-ruby-sdk/models/report_data_response'
require 'connectwise-ruby-sdk/models/reporting_service'
require 'connectwise-ruby-sdk/models/request_password_request'
require 'connectwise-ruby-sdk/models/rma_status'
require 'connectwise-ruby-sdk/models/rma_status_email_template'
require 'connectwise-ruby-sdk/models/rma_status_email_template_reference'
require 'connectwise-ruby-sdk/models/rma_status_notification'
require 'connectwise-ruby-sdk/models/rma_status_reference'
require 'connectwise-ruby-sdk/models/role'
require 'connectwise-ruby-sdk/models/sla'
require 'connectwise-ruby-sdk/models/sla_priority'
require 'connectwise-ruby-sdk/models/sla_reference'
require 'connectwise-ruby-sdk/models/sales_activity'
require 'connectwise-ruby-sdk/models/sales_probability'
require 'connectwise-ruby-sdk/models/sales_quota'
require 'connectwise-ruby-sdk/models/sales_team'
require 'connectwise-ruby-sdk/models/sales_team_member'
require 'connectwise-ruby-sdk/models/sales_team_reference'
require 'connectwise-ruby-sdk/models/schedule_color'
require 'connectwise-ruby-sdk/models/schedule_detail'
require 'connectwise-ruby-sdk/models/schedule_entry'
require 'connectwise-ruby-sdk/models/schedule_entry_reference'
require 'connectwise-ruby-sdk/models/schedule_reminder_time'
require 'connectwise-ruby-sdk/models/schedule_span_reference'
require 'connectwise-ruby-sdk/models/schedule_status'
require 'connectwise-ruby-sdk/models/schedule_status_reference'
require 'connectwise-ruby-sdk/models/schedule_stopwatch'
require 'connectwise-ruby-sdk/models/schedule_type'
require 'connectwise-ruby-sdk/models/schedule_type_reference'
require 'connectwise-ruby-sdk/models/security_role'
require 'connectwise-ruby-sdk/models/security_role_reference'
require 'connectwise-ruby-sdk/models/security_role_setting'
require 'connectwise-ruby-sdk/models/service'
require 'connectwise-ruby-sdk/models/service_code_reference'
require 'connectwise-ruby-sdk/models/service_email_template'
require 'connectwise-ruby-sdk/models/service_email_template_reference'
require 'connectwise-ruby-sdk/models/service_item_reference'
require 'connectwise-ruby-sdk/models/service_location'
require 'connectwise-ruby-sdk/models/service_location_reference'
require 'connectwise-ruby-sdk/models/service_manger'
require 'connectwise-ruby-sdk/models/service_note'
require 'connectwise-ruby-sdk/models/service_signoff'
require 'connectwise-ruby-sdk/models/service_signoff_reference'
require 'connectwise-ruby-sdk/models/service_source_reference'
require 'connectwise-ruby-sdk/models/service_status_reference'
require 'connectwise-ruby-sdk/models/service_sub_type_reference'
require 'connectwise-ruby-sdk/models/service_survey'
require 'connectwise-ruby-sdk/models/service_survey_question'
require 'connectwise-ruby-sdk/models/service_survey_question_option'
require 'connectwise-ruby-sdk/models/service_survey_reference'
require 'connectwise-ruby-sdk/models/service_team'
require 'connectwise-ruby-sdk/models/service_team_reference'
require 'connectwise-ruby-sdk/models/service_template'
require 'connectwise-ruby-sdk/models/service_template_reference'
require 'connectwise-ruby-sdk/models/service_type_reference'
require 'connectwise-ruby-sdk/models/setup_screen'
require 'connectwise-ruby-sdk/models/severity'
require 'connectwise-ruby-sdk/models/shipment_method'
require 'connectwise-ruby-sdk/models/shipment_method_reference'
require 'connectwise-ruby-sdk/models/sic_code_reference'
require 'connectwise-ruby-sdk/models/site_reference'
require 'connectwise-ruby-sdk/models/skill'
require 'connectwise-ruby-sdk/models/skill_category'
require 'connectwise-ruby-sdk/models/skill_category_reference'
require 'connectwise-ruby-sdk/models/skill_reference'
require 'connectwise-ruby-sdk/models/source'
require 'connectwise-ruby-sdk/models/state'
require 'connectwise-ruby-sdk/models/state_reference'
require 'connectwise-ruby-sdk/models/status_external_integration_reference'
require 'connectwise-ruby-sdk/models/status_workflow'
require 'connectwise-ruby-sdk/models/structure_reference'
require 'connectwise-ruby-sdk/models/sub_category'
require 'connectwise-ruby-sdk/models/success_response'
require 'connectwise-ruby-sdk/models/survey'
require 'connectwise-ruby-sdk/models/survey_option'
require 'connectwise-ruby-sdk/models/survey_question'
require 'connectwise-ruby-sdk/models/survey_question_reference'
require 'connectwise-ruby-sdk/models/survey_question_value'
require 'connectwise-ruby-sdk/models/survey_reference'
require 'connectwise-ruby-sdk/models/survey_result'
require 'connectwise-ruby-sdk/models/survey_result_detail'
require 'connectwise-ruby-sdk/models/system_department_reference'
require 'connectwise-ruby-sdk/models/system_location_reference'
require 'connectwise-ruby-sdk/models/system_menu_entry_reference'
require 'connectwise-ruby-sdk/models/task'
require 'connectwise-ruby-sdk/models/tax_code'
require 'connectwise-ruby-sdk/models/tax_code_reference'
require 'connectwise-ruby-sdk/models/tax_code_x_ref'
require 'connectwise-ruby-sdk/models/tax_integration'
require 'connectwise-ruby-sdk/models/team'
require 'connectwise-ruby-sdk/models/team_member'
require 'connectwise-ruby-sdk/models/team_role'
require 'connectwise-ruby-sdk/models/team_role_reference'
require 'connectwise-ruby-sdk/models/ticket'
require 'connectwise-ruby-sdk/models/ticket_merge'
require 'connectwise-ruby-sdk/models/ticket_reference'
require 'connectwise-ruby-sdk/models/ticket_stopwatch'
require 'connectwise-ruby-sdk/models/ticket_sync'
require 'connectwise-ruby-sdk/models/time_accrual'
require 'connectwise-ruby-sdk/models/time_accrual_detail'
require 'connectwise-ruby-sdk/models/time_accrual_reference'
require 'connectwise-ruby-sdk/models/time_entry'
require 'connectwise-ruby-sdk/models/time_entry_reference'
require 'connectwise-ruby-sdk/models/time_expense'
require 'connectwise-ruby-sdk/models/time_period'
require 'connectwise-ruby-sdk/models/time_period_setup'
require 'connectwise-ruby-sdk/models/time_period_setup_defaults'
require 'connectwise-ruby-sdk/models/time_period_setup_reference'
require 'connectwise-ruby-sdk/models/time_sheet'
require 'connectwise-ruby-sdk/models/time_sheet_reference'
require 'connectwise-ruby-sdk/models/time_zone'
require 'connectwise-ruby-sdk/models/time_zone_reference'
require 'connectwise-ruby-sdk/models/time_zone_setup'
require 'connectwise-ruby-sdk/models/time_zone_setup_reference'
require 'connectwise-ruby-sdk/models/today_page_category'
require 'connectwise-ruby-sdk/models/token'
require 'connectwise-ruby-sdk/models/track'
require 'connectwise-ruby-sdk/models/track_action'
require 'connectwise-ruby-sdk/models/track_reference'
require 'connectwise-ruby-sdk/models/type'
require 'connectwise-ruby-sdk/models/unit_of_measure'
require 'connectwise-ruby-sdk/models/unit_of_measure_reference'
require 'connectwise-ruby-sdk/models/unposted_expense'
require 'connectwise-ruby-sdk/models/unposted_invoice'
require 'connectwise-ruby-sdk/models/unposted_procurement'
require 'connectwise-ruby-sdk/models/user_defined_field'
require 'connectwise-ruby-sdk/models/user_defined_field_option'
require 'connectwise-ruby-sdk/models/user_defined_field_reference'
require 'connectwise-ruby-sdk/models/validate_portal_request'
require 'connectwise-ruby-sdk/models/validate_portal_response'
require 'connectwise-ruby-sdk/models/validation_error'
require 'connectwise-ruby-sdk/models/warehouse'
require 'connectwise-ruby-sdk/models/warehouse_bin'
require 'connectwise-ruby-sdk/models/warehouse_bin_reference'
require 'connectwise-ruby-sdk/models/warehouse_reference'
require 'connectwise-ruby-sdk/models/work_role'
require 'connectwise-ruby-sdk/models/work_role_exemption'
require 'connectwise-ruby-sdk/models/work_role_location'
require 'connectwise-ruby-sdk/models/work_role_reference'
require 'connectwise-ruby-sdk/models/work_type'
require 'connectwise-ruby-sdk/models/work_type_external_integration_reference'
require 'connectwise-ruby-sdk/models/work_type_reference'
require 'connectwise-ruby-sdk/models/workflow'
require 'connectwise-ruby-sdk/models/workflow_action'
require 'connectwise-ruby-sdk/models/workflow_action_automate_parameter'
require 'connectwise-ruby-sdk/models/workflow_event'
require 'connectwise-ruby-sdk/models/workflow_notify_type'
require 'connectwise-ruby-sdk/models/workflow_table_type'
require 'connectwise-ruby-sdk/models/workflow_table_type_reference'
require 'connectwise-ruby-sdk/models/workflow_trigger'
require 'connectwise-ruby-sdk/models/workflow_trigger_option'

# APIs
require 'connectwise-ruby-sdk/api/accounting_batches_api'
require 'connectwise-ruby-sdk/api/accounting_packages_api'
require 'connectwise-ruby-sdk/api/accounting_unposted_expenses_api'
require 'connectwise-ruby-sdk/api/accounting_unposted_procurements_api'
require 'connectwise-ruby-sdk/api/accounting_unpostedinvoices_api'
require 'connectwise-ruby-sdk/api/activities_api'
require 'connectwise-ruby-sdk/api/activity_statuses_api'
require 'connectwise-ruby-sdk/api/activity_stopwatches_api'
require 'connectwise-ruby-sdk/api/activity_types_api'
require 'connectwise-ruby-sdk/api/address_formats_api'
require 'connectwise-ruby-sdk/api/adjustment_details_api'
require 'connectwise-ruby-sdk/api/adjustment_types_api'
require 'connectwise-ruby-sdk/api/adjustments_api'
require 'connectwise-ruby-sdk/api/agreement_additions_api'
require 'connectwise-ruby-sdk/api/agreement_adjustments_api'
require 'connectwise-ruby-sdk/api/agreement_batch_setups_api'
require 'connectwise-ruby-sdk/api/agreement_board_defaults_api'
require 'connectwise-ruby-sdk/api/agreement_sites_api'
require 'connectwise-ruby-sdk/api/agreement_type_board_defaults_api'
require 'connectwise-ruby-sdk/api/agreement_type_work_role_exclusions_api'
require 'connectwise-ruby-sdk/api/agreement_type_work_roles_api'
require 'connectwise-ruby-sdk/api/agreement_type_work_type_exclusions_api'
require 'connectwise-ruby-sdk/api/agreement_type_work_types_api'
require 'connectwise-ruby-sdk/api/agreement_types_api'
require 'connectwise-ruby-sdk/api/agreement_work_role_exclusions_api'
require 'connectwise-ruby-sdk/api/agreement_work_roles_api'
require 'connectwise-ruby-sdk/api/agreement_work_type_exclusions_api'
require 'connectwise-ruby-sdk/api/agreement_work_types_api'
require 'connectwise-ruby-sdk/api/agreements_api'
require 'connectwise-ruby-sdk/api/audit_trail_api'
require 'connectwise-ruby-sdk/api/auth_anvils_api'
require 'connectwise-ruby-sdk/api/batch_api'
require 'connectwise-ruby-sdk/api/billing_cycles_api'
require 'connectwise-ruby-sdk/api/billing_setup_routings_api'
require 'connectwise-ruby-sdk/api/billing_setups_api'
require 'connectwise-ruby-sdk/api/billing_statuses_api'
require 'connectwise-ruby-sdk/api/billing_terms_api'
require 'connectwise-ruby-sdk/api/board_auto_assign_resources_api'
require 'connectwise-ruby-sdk/api/board_auto_templates_api'
require 'connectwise-ruby-sdk/api/board_excluded_members_api'
require 'connectwise-ruby-sdk/api/board_item_associations_api'
require 'connectwise-ruby-sdk/api/board_items_api'
require 'connectwise-ruby-sdk/api/board_notifications_api'
require 'connectwise-ruby-sdk/api/board_status_notifications_api'
require 'connectwise-ruby-sdk/api/board_statuses_api'
require 'connectwise-ruby-sdk/api/board_sub_types_api'
require 'connectwise-ruby-sdk/api/board_teams_api'
require 'connectwise-ruby-sdk/api/board_type_sub_type_item_associations_api'
require 'connectwise-ruby-sdk/api/board_types_api'
require 'connectwise-ruby-sdk/api/boards_api'
require 'connectwise-ruby-sdk/api/calendars_api'
require 'connectwise-ruby-sdk/api/callbacks_api'
require 'connectwise-ruby-sdk/api/campaign_audits_api'
require 'connectwise-ruby-sdk/api/campaign_emails_opened_api'
require 'connectwise-ruby-sdk/api/campaign_forms_submitted_api'
require 'connectwise-ruby-sdk/api/campaign_links_clicked_api'
require 'connectwise-ruby-sdk/api/campaign_statuses_api'
require 'connectwise-ruby-sdk/api/campaign_sub_types_api'
require 'connectwise-ruby-sdk/api/campaign_types_api'
require 'connectwise-ruby-sdk/api/campaigns_api'
require 'connectwise-ruby-sdk/api/catalog_components_api'
require 'connectwise-ruby-sdk/api/catalogs_item_api'
require 'connectwise-ruby-sdk/api/categories_api'
require 'connectwise-ruby-sdk/api/certifications_api'
require 'connectwise-ruby-sdk/api/charge_code_expense_types_api'
require 'connectwise-ruby-sdk/api/charge_codes_api'
require 'connectwise-ruby-sdk/api/classifications_api'
require 'connectwise-ruby-sdk/api/codes_api'
require 'connectwise-ruby-sdk/api/commissions_api'
require 'connectwise-ruby-sdk/api/companies_api'
require 'connectwise-ruby-sdk/api/company_custom_notes_api'
require 'connectwise-ruby-sdk/api/company_groups_api'
require 'connectwise-ruby-sdk/api/company_management_summary_reports_api'
require 'connectwise-ruby-sdk/api/company_note_types_api'
require 'connectwise-ruby-sdk/api/company_notes_api'
require 'connectwise-ruby-sdk/api/company_picker_items_api'
require 'connectwise-ruby-sdk/api/company_sites_api'
require 'connectwise-ruby-sdk/api/company_statuses_api'
require 'connectwise-ruby-sdk/api/company_teams_api'
require 'connectwise-ruby-sdk/api/company_types_api'
require 'connectwise-ruby-sdk/api/configuration_statuses_api'
require 'connectwise-ruby-sdk/api/configuration_type_question_values_api'
require 'connectwise-ruby-sdk/api/configuration_type_questions_api'
require 'connectwise-ruby-sdk/api/configuration_types_api'
require 'connectwise-ruby-sdk/api/configurations_api'
require 'connectwise-ruby-sdk/api/connect_wise_hosted_setups_api'
require 'connectwise-ruby-sdk/api/contact_communications_api'
require 'connectwise-ruby-sdk/api/contact_departments_api'
require 'connectwise-ruby-sdk/api/contact_groups_api'
require 'connectwise-ruby-sdk/api/contact_notes_api'
require 'connectwise-ruby-sdk/api/contact_relationships_api'
require 'connectwise-ruby-sdk/api/contact_tracks_api'
require 'connectwise-ruby-sdk/api/contact_types_api'
require 'connectwise-ruby-sdk/api/contacts_api'
require 'connectwise-ruby-sdk/api/corporate_structure_levels_api'
require 'connectwise-ruby-sdk/api/corporate_structures_api'
require 'connectwise-ruby-sdk/api/countries_api'
require 'connectwise-ruby-sdk/api/crms_api'
require 'connectwise-ruby-sdk/api/currencies_api'
require 'connectwise-ruby-sdk/api/custom_report_parameters_api'
require 'connectwise-ruby-sdk/api/custom_reports_api'
require 'connectwise-ruby-sdk/api/delivery_methods_api'
require 'connectwise-ruby-sdk/api/department_locations_api'
require 'connectwise-ruby-sdk/api/departments_api'
require 'connectwise-ruby-sdk/api/documents_api'
require 'connectwise-ruby-sdk/api/documents_setup_api'
require 'connectwise-ruby-sdk/api/email_connector_parsing_rules_api'
require 'connectwise-ruby-sdk/api/email_connector_parsing_styles_api'
require 'connectwise-ruby-sdk/api/email_connectors_api'
require 'connectwise-ruby-sdk/api/email_tokens_api'
require 'connectwise-ruby-sdk/api/expense_entries_api'
require 'connectwise-ruby-sdk/api/expense_reports_api'
require 'connectwise-ruby-sdk/api/expense_type_external_integration_references_api'
require 'connectwise-ruby-sdk/api/expense_types_api'
require 'connectwise-ruby-sdk/api/group_companies_api'
require 'connectwise-ruby-sdk/api/group_contacts_api'
require 'connectwise-ruby-sdk/api/groups_api'
require 'connectwise-ruby-sdk/api/holiday_lists_api'
require 'connectwise-ruby-sdk/api/holidays_api'
require 'connectwise-ruby-sdk/api/imaps_api'
require 'connectwise-ruby-sdk/api/impacts_api'
require 'connectwise-ruby-sdk/api/imports_mass_maintenance_api'
require 'connectwise-ruby-sdk/api/in_out_boards_api'
require 'connectwise-ruby-sdk/api/in_out_types_api'
require 'connectwise-ruby-sdk/api/info_api'
require 'connectwise-ruby-sdk/api/integrator_logins_api'
require 'connectwise-ruby-sdk/api/invoice_email_templates_api'
require 'connectwise-ruby-sdk/api/invoice_payments_api'
require 'connectwise-ruby-sdk/api/invoice_template_setups_api'
require 'connectwise-ruby-sdk/api/invoice_templates_api'
require 'connectwise-ruby-sdk/api/invoices_api'
require 'connectwise-ruby-sdk/api/kpi_categories_api'
require 'connectwise-ruby-sdk/api/kp_is_api'
require 'connectwise-ruby-sdk/api/knowledge_base_articles_api'
require 'connectwise-ruby-sdk/api/ldap_configurations_api'
require 'connectwise-ruby-sdk/api/legacy_campaign_sub_types_api'
require 'connectwise-ruby-sdk/api/legacy_sub_categories_api'
require 'connectwise-ruby-sdk/api/links_api'
require 'connectwise-ruby-sdk/api/location_departments_api'
require 'connectwise-ruby-sdk/api/location_work_roles_api'
require 'connectwise-ruby-sdk/api/locations_api'
require 'connectwise-ruby-sdk/api/managed_devices_integration_cross_references_api'
require 'connectwise-ruby-sdk/api/managed_devices_integration_logins_api'
require 'connectwise-ruby-sdk/api/managed_devices_integration_notifications_api'
require 'connectwise-ruby-sdk/api/managed_devices_integrations_api'
require 'connectwise-ruby-sdk/api/management_backups_api'
require 'connectwise-ruby-sdk/api/management_emails_api'
require 'connectwise-ruby-sdk/api/management_execute_managed_it_syncs_api'
require 'connectwise-ruby-sdk/api/management_it_solution_agreement_interface_parameters_api'
require 'connectwise-ruby-sdk/api/management_it_solutions_api'
require 'connectwise-ruby-sdk/api/management_logs_api'
require 'connectwise-ruby-sdk/api/management_networks_security_api'
require 'connectwise-ruby-sdk/api/management_report_notifications_api'
require 'connectwise-ruby-sdk/api/managements_api'
require 'connectwise-ruby-sdk/api/manufacturers_api'
require 'connectwise-ruby-sdk/api/market_descriptions_api'
require 'connectwise-ruby-sdk/api/member_accruals_api'
require 'connectwise-ruby-sdk/api/member_certifications_api'
require 'connectwise-ruby-sdk/api/member_delegations_api'
require 'connectwise-ruby-sdk/api/member_skills_api'
require 'connectwise-ruby-sdk/api/member_types_api'
require 'connectwise-ruby-sdk/api/members_api'
require 'connectwise-ruby-sdk/api/menu_entries_api'
require 'connectwise-ruby-sdk/api/menu_entry_locations_api'
require 'connectwise-ruby-sdk/api/my_company_purchasings_api'
require 'connectwise-ruby-sdk/api/notification_recipients_api'
require 'connectwise-ruby-sdk/api/opportunities_api'
require 'connectwise-ruby-sdk/api/opportunity_contacts_api'
require 'connectwise-ruby-sdk/api/opportunity_forecasts_api'
require 'connectwise-ruby-sdk/api/opportunity_notes_api'
require 'connectwise-ruby-sdk/api/opportunity_ratings_api'
require 'connectwise-ruby-sdk/api/opportunity_stages_api'
require 'connectwise-ruby-sdk/api/opportunity_statuses_api'
require 'connectwise-ruby-sdk/api/opportunity_teams_api'
require 'connectwise-ruby-sdk/api/opportunity_types_api'
require 'connectwise-ruby-sdk/api/order_status_notifications_api'
require 'connectwise-ruby-sdk/api/order_statuses_api'
require 'connectwise-ruby-sdk/api/order_statuses_email_template_api'
require 'connectwise-ruby-sdk/api/orders_api'
require 'connectwise-ruby-sdk/api/others_api'
require 'connectwise-ruby-sdk/api/ownership_types_api'
require 'connectwise-ruby-sdk/api/parsing_types_api'
require 'connectwise-ruby-sdk/api/parsing_variables_api'
require 'connectwise-ruby-sdk/api/payment_types_api'
require 'connectwise-ruby-sdk/api/portal_calendars_api'
require 'connectwise-ruby-sdk/api/portal_configuration_invoice_setups_api'
require 'connectwise-ruby-sdk/api/portal_configuration_opportunity_setups_api'
require 'connectwise-ruby-sdk/api/portal_configuration_password_email_setups_api'
require 'connectwise-ruby-sdk/api/portal_configuration_project_setups_api'
require 'connectwise-ruby-sdk/api/portal_configuration_service_setups_api'
require 'connectwise-ruby-sdk/api/portal_configurations_api'
require 'connectwise-ruby-sdk/api/portal_reports_api'
require 'connectwise-ruby-sdk/api/portal_securities_api'
require 'connectwise-ruby-sdk/api/portal_security_levels_api'
require 'connectwise-ruby-sdk/api/pricing_breaks_api'
require 'connectwise-ruby-sdk/api/pricing_details_api'
require 'connectwise-ruby-sdk/api/pricing_schedules_api'
require 'connectwise-ruby-sdk/api/priorities_api'
require 'connectwise-ruby-sdk/api/product_components_api'
require 'connectwise-ruby-sdk/api/product_picking_shipping_details_api'
require 'connectwise-ruby-sdk/api/product_types_api'
require 'connectwise-ruby-sdk/api/products_item_api'
require 'connectwise-ruby-sdk/api/project_contacts_api'
require 'connectwise-ruby-sdk/api/project_notes_api'
require 'connectwise-ruby-sdk/api/project_phases_api'
require 'connectwise-ruby-sdk/api/project_security_role_settings_api'
require 'connectwise-ruby-sdk/api/project_security_roles_api'
require 'connectwise-ruby-sdk/api/project_statuses_api'
require 'connectwise-ruby-sdk/api/project_types_api'
require 'connectwise-ruby-sdk/api/projects_api'
require 'connectwise-ruby-sdk/api/projects_teammembers_api'
require 'connectwise-ruby-sdk/api/purchase_order_line_items_api'
require 'connectwise-ruby-sdk/api/purchase_order_status_email_templates_api'
require 'connectwise-ruby-sdk/api/purchase_order_status_notifications_api'
require 'connectwise-ruby-sdk/api/purchase_order_statuses_api'
require 'connectwise-ruby-sdk/api/purchase_orders_api'
require 'connectwise-ruby-sdk/api/rma_actions_api'
require 'connectwise-ruby-sdk/api/rma_dispositions_api'
require 'connectwise-ruby-sdk/api/report_card_details_api'
require 'connectwise-ruby-sdk/api/report_cards_api'
require 'connectwise-ruby-sdk/api/reporting_services_api'
require 'connectwise-ruby-sdk/api/reports_api'
require 'connectwise-ruby-sdk/api/rma_status_email_templates_api'
require 'connectwise-ruby-sdk/api/rma_status_notifications_api'
require 'connectwise-ruby-sdk/api/rma_statuses_api'
require 'connectwise-ruby-sdk/api/roles_api'
require 'connectwise-ruby-sdk/api/sla_priorities_api'
require 'connectwise-ruby-sdk/api/sl_as_api'
require 'connectwise-ruby-sdk/api/sales_probabilities_api'
require 'connectwise-ruby-sdk/api/sales_quotas_api'
require 'connectwise-ruby-sdk/api/sales_team_members_api'
require 'connectwise-ruby-sdk/api/sales_teams_api'
require 'connectwise-ruby-sdk/api/schedule_colors_api'
require 'connectwise-ruby-sdk/api/schedule_details_api'
require 'connectwise-ruby-sdk/api/schedule_entries_api'
require 'connectwise-ruby-sdk/api/schedule_reminder_times_api'
require 'connectwise-ruby-sdk/api/schedule_statuses_api'
require 'connectwise-ruby-sdk/api/schedule_stopwatches_api'
require 'connectwise-ruby-sdk/api/schedule_types_api'
require 'connectwise-ruby-sdk/api/security_role_settings_api'
require 'connectwise-ruby-sdk/api/security_roles_api'
require 'connectwise-ruby-sdk/api/service_email_templates_api'
require 'connectwise-ruby-sdk/api/service_locations_api'
require 'connectwise-ruby-sdk/api/service_signoffs_api'
require 'connectwise-ruby-sdk/api/service_survey_questions_api'
require 'connectwise-ruby-sdk/api/service_surveys_api'
require 'connectwise-ruby-sdk/api/service_teams_api'
require 'connectwise-ruby-sdk/api/service_templates_api'
require 'connectwise-ruby-sdk/api/services_api'
require 'connectwise-ruby-sdk/api/setup_screens_api'
require 'connectwise-ruby-sdk/api/severities_api'
require 'connectwise-ruby-sdk/api/shipment_methods_api'
require 'connectwise-ruby-sdk/api/skill_categories_api'
require 'connectwise-ruby-sdk/api/skills_api'
require 'connectwise-ruby-sdk/api/sources_api'
require 'connectwise-ruby-sdk/api/states_api'
require 'connectwise-ruby-sdk/api/status_external_integration_references_api'
require 'connectwise-ruby-sdk/api/sub_categories_api'
require 'connectwise-ruby-sdk/api/survey_options_api'
require 'connectwise-ruby-sdk/api/survey_question_values_api'
require 'connectwise-ruby-sdk/api/survey_questions_api'
require 'connectwise-ruby-sdk/api/survey_results_api'
require 'connectwise-ruby-sdk/api/surveys_api'
require 'connectwise-ruby-sdk/api/system_tracks_api'
require 'connectwise-ruby-sdk/api/tax_code_expense_type_exemptions_api'
require 'connectwise-ruby-sdk/api/tax_code_product_type_exemptions_api'
require 'connectwise-ruby-sdk/api/tax_code_work_role_exemptions_api'
require 'connectwise-ruby-sdk/api/tax_code_x_refs_api'
require 'connectwise-ruby-sdk/api/tax_codes_api'
require 'connectwise-ruby-sdk/api/tax_integrations_api'
require 'connectwise-ruby-sdk/api/team_members_api'
require 'connectwise-ruby-sdk/api/team_roles_api'
require 'connectwise-ruby-sdk/api/ticket_notes_api'
require 'connectwise-ruby-sdk/api/ticket_stopwatches_api'
require 'connectwise-ruby-sdk/api/ticket_syncs_api'
require 'connectwise-ruby-sdk/api/ticket_tasks_api'
require 'connectwise-ruby-sdk/api/tickets_api'
require 'connectwise-ruby-sdk/api/time_accrual_details_api'
require 'connectwise-ruby-sdk/api/time_accruals_api'
require 'connectwise-ruby-sdk/api/time_entries_api'
require 'connectwise-ruby-sdk/api/time_expenses_api'
require 'connectwise-ruby-sdk/api/time_period_setups_api'
require 'connectwise-ruby-sdk/api/time_periods_api'
require 'connectwise-ruby-sdk/api/time_sheets_api'
require 'connectwise-ruby-sdk/api/time_zone_setups_api'
require 'connectwise-ruby-sdk/api/time_zones_api'
require 'connectwise-ruby-sdk/api/today_page_categories_api'
require 'connectwise-ruby-sdk/api/track_actions_api'
require 'connectwise-ruby-sdk/api/unit_of_measure_conversions_api'
require 'connectwise-ruby-sdk/api/unit_of_measures_api'
require 'connectwise-ruby-sdk/api/user_defined_fields_api'
require 'connectwise-ruby-sdk/api/warehouse_bins_api'
require 'connectwise-ruby-sdk/api/warehouses_api'
require 'connectwise-ruby-sdk/api/work_role_locations_api'
require 'connectwise-ruby-sdk/api/work_roles_api'
require 'connectwise-ruby-sdk/api/work_type_external_integration_references_api'
require 'connectwise-ruby-sdk/api/work_types_api'
require 'connectwise-ruby-sdk/api/workflow_action_automate_parameters_api'
require 'connectwise-ruby-sdk/api/workflow_actions_api'
require 'connectwise-ruby-sdk/api/workflow_events_api'
require 'connectwise-ruby-sdk/api/workflow_notify_types_api'
require 'connectwise-ruby-sdk/api/workflow_table_types_api'
require 'connectwise-ruby-sdk/api/workflow_trigger_options_api'
require 'connectwise-ruby-sdk/api/workflow_triggers_api'
require 'connectwise-ruby-sdk/api/workflows_api'

module ConnectWise
  class << self
    # Customize default settings for the SDK using block.
    #   ConnectWise.configure do |config|
    #     config.username = "xxx"
    #     config.password = "xxx"
    #   end
    # If no block given, return the default Configuration object.
    def configure
      if block_given?
        yield(Configuration.default)
      else
        Configuration.default
      end
    end
  end
end
